﻿var columnsData;
var specData;
var button = "";
var columns = [[]];
var columnfit;
var CatalogId = "";
var ProductName = "";
var ProductId = "";

function InitProductSpec() {

    myAjax({
        url: serverURL + "/Product/GetSpecHeadByProductId",
        data: { ProductId: ProductId },
        method: "POST",
        dataType: 'json'
    }, function (data) {
        //columnsData = eval('(' + data + ')');
        columnsData = data;
        myAjax({
            url: serverURL + "/Product/GetSpecDataByProductId",
            data: { ProductId: ProductId },
            method: "POST",
            dataType: 'json'
        }, function (data) {
            // specData = eval('(' + data + ')');
            specData = data;
            columns = [[]];
            var ProductManual = JSON.parse(window.localStorage.getItem("ProductManual"));
            var colWidthSum = 60;
            for (var item in columnsData) {
                for (var index in columnsData[item]) {
                    if (index != "ParamName") {
                        var productid = index;
                        var disabled = "";
                        $$.each(ProductManual, function (index, value) {
                            if (value.productid == productid) {
                                disabled = "disabled='disabled'";
                            }
                        });

                        button = "<a href=\"javascript:void(0)\" " + disabled + " onclick=\"SelectContrastProduct(this,'" + index + "')\" specid=\"" + index + "\" class=\"easyui-linkbutton l-btn l-btn-small l-btn-plain\" data-options=\"iconCls:'icon-pk',plain:true\" >" +
                                "<span class=\"l-btn-left l-btn-icon-left\" style=\"margin-right: 5px;\"><span class=\"l-btn-text l-btn-empty\">&nbsp;</span><span class=\"l-btn-icon icon-pk\">&nbsp;</span></span></a>";

                        var colWidth = 0;
                        if (columnsData[item][index].length <= 8) {
                            colWidth = 100;
                        } else {
                            colWidth = (columnsData[item][index].length - 8) * 8 + 100;
                        }
                        colWidthSum += colWidth;
                        columns[0].push({ field: index, title: button + columnsData[item][index], width: colWidth });
                    }
                }
            }

            columnfit = window.innerWidth > colWidthSum ? true : false;
            $('#ProductSpec').datagrid({
                data: specData,
                height: 400,
                fitColumns: columnfit,
                frozenColumns: [[{
                    field: "ParamName", title: "参数", width: 60, styler: function (value, row, index) {
                        return 'background-color:#efeff4;';
                    }
                }]],
                columns: columns,
                nowrap: false
            });

        }, function (xhr, status) {
            //Notify();
        });

    }, function (xhr, status) {
        //Notify();
    });
}

function InitImagePath(jq) {
    if (serverURL != "") {
        $$.each(jq.find("img"), function (index, value) {
            $$(value).attr("src", serverURL + $$(value).attr("src"));
        });
    }
}

function InitProductDetail() {

    QueryShowNum();
    myApp.showIndicator();
    myAjax({
        url: serverURL + '/Product/GetProductDetail',
        data: { CatalogId: CatalogId },
        method: 'POST',
        cache: false,
        dataType: 'json'
    }, function (data, status, xhr) {
        try {
            if (data.length == 0) {
                var html = Template7.templates.noResult_template({ info: "没有该产品数据" });
                $$("#ProductDetailContent").html(html);
                return;
            }

            ProductId = data.ProductId;
            ProductName = data.ProductName;
            $$('#IsShare').attr("data-title", ProductName);
            InitProductSpec();
            $$("#ProductName").html(data.ProductName);
            $$("#Summary").html(data.Summary);
            InitImagePath($$("#Summary"));
            $$("#Characteristic").html(data.Characteristic);
            InitImagePath($$("#Characteristic"));
            if (data.Networking != null && data.Networking != "") {
                $$("#Networking").html(data.Networking);
                InitImagePath($$("#Networking"));
                $$("#divNetworking").show();
            }

            if (data.OrderInfo != null && data.OrderInfo != "") {
                $$("#OrderInfo").html(data.OrderInfo);
                InitImagePath($$("#OrderInfo"));
                $$("#divOrderInfo").show();
            }

            if (data.MatchInfo != null && data.MatchInfo != "") {
                $$("#MatchInfo").html(data.MatchInfo);
                InitImagePath($$("#MatchInfo"));
                $$("#divMatchInfo").show();
            }

            var ProductImages = "";
            var ProductVideos = "";
            $$.each(data.Attachments, function (index, value) {

                if (value.Type == "1") {
                    ProductImages += " <div class=\"swiper-slide\"><img class=\"imgclass\" src=\"" + serverURL + value.URL + "\"></div>";
                } else if (value.Type == "2") {
                    if (!myAPIClient.isApiReady()) {
                        ProductVideos += "<div class=\"swiper-slide\">" +
                                            "<video style=\"margin: 0 auto; width: 100%; height: 100%;\" preload=\"auto\" controls=\"controls\" poster=\"" + serverURL + value.ThumbnailURL + "\">" +
                                                "<source src=\"" + serverURL + value.URL + "\" type=\"video/mp4\">" +
                                                "您的浏览器不支持 video 标签。" +
                                            "</video>" +
                                          "</div>";
                    } else {
                        ProductVideos += "<div class=\"swiper-slide\">" +
                                     "<div style=\"position:relative;text-align:center;\">" +
                                       "<div style=\"position: absolute;\">" +
                                       " <img class=\"play\" onclick=\"fnPlay('" + serverURL + value.URL + "')\" src=\"Content/images/button/play.png\"></div>" +
                                      "<img  class=\"imgclass2\" src=\"" + serverURL + value.ThumbnailURL + "\"></div>" +
                                    "</div>";
                    }
                }
            });

            if (ProductImages != "") {
                $$("#ProductImage").html(ProductImages);
                $$("#divProductImage").show();
                myApp.swiper('#productimage-swiper-container', {
                    pagination: '#productimage-swiper-pagination',
                    paginationHide: false,
                    paginationClickable: true,
                    nextButton: '#productimage-swiper-button-next',
                    prevButton: '#productimage-swiper-button-prev',
                });
            }

            if (ProductVideos != "") {
                $$("#ProductVideo").html(ProductVideos);
                if (myAPIClient.isApiReady()) {

                    $$(".imgclass2").css({ "height": $$(".imgclass2").parent().parent().height() + "px" });
                    $$(".play").css({
                        height: "50px",
                        width: "50px",
                        top: ($$(".play").parent().parent().parent().height() / 2 - 25) + "px",
                        left: ($$(".play").parent().parent().parent().width() / 2 - 25) + "px",
                        position: "absolute"
                    });
                }
                $$("#divProductVideo").show();

                myApp.swiper('#productvideo-swiper-container', {
                    pagination: '#productvideo-swiper-pagination',
                    paginationHide: false,
                    paginationClickable: true,
                    nextButton: '#productvideo-swiper-button-next',
                    prevButton: '#productvideo-swiper-button-prev',
                });
            } else {
                $$("#divProductVideo").hide();
            }
        } catch (e) { }
        finally {
            myApp.hideIndicator();
        }
    }, function (xhr, status) {
        myApp.hideIndicator();
        //Notify();
    });
}

function SelectContrastProduct(dom, specId) {
    $$(dom).attr("disabled", "disabled");
    myApp.showIndicator();
    myAjax({
        url: serverURL + "/Product/GetSpecificationById",
        data: { specId: specId },
        dataType: 'json'
    }, function (data) {
        // data = eval('(' + data + ')');
        try {
            var storage = window.localStorage.getItem("ProductManual");
            var temp = [];
            if (storage != null) {
                temp = JSON.parse(storage);
            }
            temp.push({ productid: data.SpecId, productname: data.SpecName });
            window.localStorage.setItem("ProductManual", JSON.stringify(temp));

            QueryShowNum();
        } catch (e) { }
        finally {
            myApp.hideIndicator();
        }
    }, function (xhr, status) {
        myApp.hideIndicator();
        //Notify();
    });
}

var contrastResultHead;
var contrastResultData;
function InitContrastResult(productids) {

    myAjax({
        url: serverURL + "/Product/GetContrastResultHead",
        data: { productids: productids },
        method: "POST",
        dataType: 'json'
    }, function (data) {

        //contrastResultHead = eval('(' + data + ')');
        myApp.showIndicator();
        contrastResultHead = data;
        myAjax({
            url: serverURL + "/Product/GetContrastResultData",
            data: { productids: productids },
            method: "POST",
            dataType: 'json'
        }, function (data) {

            //contrastResultData = eval('(' + data + ')');
            try {
                contrastResultData = data;
                var columns = [[]];
                var colWidthSum = 60;
                for (var item in contrastResultHead) {
                    for (var index in contrastResultHead[item]) {
                        var button = "";
                        if (index != "ParamName") {
                            var colWidth = 0;
                            if (contrastResultHead[item][index].length <= 8) {
                                colWidth = 100;
                            } else {
                                colWidth = (contrastResultHead[item][index].length - 8) * 8 + 100;
                            }
                            colWidthSum += colWidth;
                            columns[0].push({ field: index, title: contrastResultHead[item][index], width: colWidth });
                        }
                    }
                }

                columnfit = window.innerWidth > colWidthSum ? true : false;
                $('#ContrastResult').datagrid({
                    data: contrastResultData,
                    top: 63,
                    fit: true,
                    fitColumns: columnfit,
                    height: 500,
                    frozenColumns: [[{
                        field: "ParamName", title: "参数", width: 60, styler: function (value, row, index) {
                            return 'background-color:#efeff4;';
                        }
                    }]],
                    columns: columns,
                    nowrap: false
                });
            } catch (e) { }
            finally {
                myApp.hideIndicator();
            }
        }, function (xhr, status) {
            myApp.hideIndicator();
            //Notify();
        });
    }, function (xhr, status) {
        //Notify();
    });
}


$(function () {

    var isShare = GetParamValueFromLocation("isShare");
    CatalogId = GetParamValueFromLocation("CatalogId");
    if (isShare == "true") {
        $$("#IsShare").attr("style", "display:none");
        InitProductDetail();
    }

    $$(document).on('pageInit', function (e) {
        var page = e.detail.page;
        if (page.name == 'ContrastSelect') {
            $$("#BtnContrastSelectMenu").on('click', function () {
                myApp.popover($$("#popContrastSelectMenu"), $$("#BtnContrastSelectMenu"));
            });
            Query();
        } else if (page.name == 'ProductDetail') {
            CatalogId = page.query.CatalogId;
            if (page.query.isShare == "true") {
                $$("#IsShare").attr("style", "display:none");
            }
            InitProductDetail();
            $$('#IsShare').attr("data-url", serverURL + "/Product/ProductDetail?CatalogId=" + CatalogId + "&isShare=true");
        } else if (page.name == 'SelectProduct') {
            QuerySelectProduct();
            myApp.showIndicator();
            myAjax({
                url: serverURL + "/Product/GetProductListByCatalogId",
                data: { CatalogId: page.query.CatalogPid },
                method: "POST",
                dataType: 'json'
            }, function (data) {
                //data = JSON.parse(data);
                try {
                    if (data.length == 0) {
                        var html = Template7.templates.noResult_template({ info: "没有该产品的型号数据" });
                        $$("#pageSelectProduct").html(html);
                        return;
                    }
                    EmployeeList = myApp.virtualList('#ProductList', {
                        cache: true,
                        items: data,
                        renderItem: function (index, item) {

                            var checked = "";
                            if ($$('#SelProductList input[value="' + item.ProductId + '"]').length > 0)
                                checked = 'checked = "checked"';

                            return '<li> <label class="label-checkbox item-content" style="padding-left: 5px;">' +
                               '<input type="checkbox" name="product" data-productname="' + item.ProductName + '" onchange="checkboxOnchange(this)"  value="' + item.ProductId + '"' + checked + '>' +
                                 '<div class="item-media">' +
                                   '<i class="icon icon-form-checkbox"></i>' +
                                    '</div>' +
                                    '<div class="item-inner" style="padding-top:0px;padding-bottom:0px;padding-right:0px;">' +
                                  '<div class="item-title" style="font-size:smaller; white-space: normal">' + item.ProductName + '</div>' +
                                 '</div>' +
                              '</label>' +
                             '</li>';
                        },
                        searchByItem: function (query, index, item) {

                            if (item.ProductName.toLowerCase().indexOf(query.trim().toLowerCase()) >= 0) {
                                return true;
                            }
                            else {
                                return false;
                            }
                        }
                    });
                } catch (e) { }
                finally {
                    myApp.hideIndicator();
                }

            }, function (xhr, status) {
                myApp.hideIndicator();
                //Notify();
            });

        } else if (page.name == 'ContrastResult') {
            var productids = page.query.productids;
            InitContrastResult(productids);
        } else if (page.name == 'SelectCatalog') {

            myApp.showIndicator();
            myAjax({
                url: serverURL + "/Product/GetSelectCatalog",
                method: "POST",
                dataType: 'json'
            }, function (data) {
                //data = JSON.parse(data);
                try {
                    var html = Template7.templates.SelectCatalogTemplate(data);
                    $$("#ulSelectCatalog").html(html);
                } catch (e) { }
                finally {
                    myApp.hideIndicator();
                }
            }, function (xhr, status) {
                myApp.hideIndicator();
                //Notify();
            });
        }
    });
});

var noSelected = " <li style=\"top: 0px;\">" +
                       " <label class=\"label-checkbox item-content\" style=\"padding-left: 5px;\"> " +
                           " <div class=\"item-inner\" style=\"padding-top:0px;padding-bottom:0px;padding-right:0px;\">" +
                              "  <div class=\"item-title\" style=\"font-size:smaller; white-space: normal\">还未选择产品</div> " +
                            "</div>" +
                        "</label>" +
                    "</li>";

function checkboxOnchange(dom) {

    var html = "<li style=\"top: 0px;\"><label class=\"label-checkbox item-content\" style=\"padding-left: 5px;\">";
    html = html + "<input type=\"hidden\" name=\"selectedproduct\" data-productname=\"" + $$(dom).data("productname") + "\" value=\"" + $$(dom).val() + "\">";
    html = html + "<div class=\"item-inner\" style=\"padding-top:0px;padding-bottom:0px;padding-right:0px;\">";
    html = html + "<div class=\"item-title\" style=\"font-size:smaller; white-space: normal\">" + $$(dom).data("productname") + "</div>";
    html = html + "</div></label></li>"

    var len = $$("input[name='selectedproduct']").length;
    if (len == 0) {
        $$("#SelProductList ul").html(html);
    } else {
        var len2 = $$("input[name='selectedproduct'][value='" + $$(dom).val() + "']").length;
        var checked = $$(dom).prop("checked");
        if (checked && len2 == 0) {
            $$("#SelProductList ul").append(html)
        }

        if (!checked && len2 > 0) {
            $$("input[name='selectedproduct'][value='" + $$(dom).val() + "']").parent().parent().remove();
            if ($$("input[name='selectedproduct']").length == 0) {
                $$("#SelProductList ul").html(noSelected);
            }
        }
    }

}

function SelectProduct() {

    var storage = [];
    var list = $$("input[name='selectedproduct']");
    $$.each(list, function (index, value) {
        storage.push({ productid: $$(value).val(), productname: $$(value).data("productname") });
    });
    window.localStorage.setItem("ProductManual", JSON.stringify(storage));
    OpenContrastSelect();
}

function OpenContrastSelect() {
    if (serverURL == "") {
        loadPage(serverURL + '/Product/ContrastSelect');
    } else {
        loadPage('ContrastSelect.html');
    }
}

function Delete(productid) {
    var storage = window.localStorage.getItem("ProductManual");
    if (storage != null) {
        var ProductManual = JSON.parse(storage);
        if (ProductManual.length > 0) {
            $$.each(ProductManual, function (index, value) {
                if (value.productid == productid) {
                    ProductManual.splice(index, 1);
                }
            });

            window.localStorage.setItem("ProductManual", JSON.stringify(ProductManual));
        }
    }
}

var noContrastSelect = Template7.templates.noResult_template({ info: "产品库还空着呐！添加产品对比吧" });

function Query() {

    var storage = window.localStorage.getItem("ProductManual");
    if (storage != null) {
        var ProductManual = JSON.parse(storage);
        if (ProductManual.length > 0) {
            var html = "";
            $$.each(ProductManual, function (index, value) {
                html += "<li style=\"top: 0px;\">" +
                        "<label class=\"label-checkbox item-content\" onclick=\"Prompt()\" style=\"padding-left: 5px;\">" +
                            "<input type=\"checkbox\" name=\"ContrastSelect\" data-productname=\"" + value.productname + "\" value=\"" + value.productid + "\">" +
                            "<div class=\"item-media\"><i class=\"icon icon-form-checkbox\"></i></div>" +
                            "<div class=\"item-inner\" style=\"padding-top:0px;padding-bottom:0px;padding-right:0px;\">" +
                              "<div class=\"item-title\" style=\"font-size:smaller; white-space: normal\">" + value.productname + "</div>" +
                            "</div>" +
                          "</label>" +
                        "</li>";
            });
            $$("#ContrastSelectList ul").html(html);
        } else {
            $$("#pageContrastSelect").html(noContrastSelect);
        }
    } else {
        $$("#pageContrastSelect").html(noContrastSelect);
    }
}

function Prompt() {

    var len = $$("input[name='ContrastSelect']:checked").length;
    if (len > 9) {
        myApp.alert("抱歉，最多支持9款产品型号对比哦", "提示");
        event.preventDefault();
    }
}



function QuerySelectProduct() {

    var storage = window.localStorage.getItem("ProductManual");
    if (storage != null) {
        var ProductManual = JSON.parse(storage);
        if (ProductManual.length > 0) {
            var html = "";
            $$.each(ProductManual, function (index, value) {
                html += "<li style=\"top: 0px;\"><label class=\"label-checkbox item-content\" style=\"padding-left: 5px;\">" +
                              "<input type=\"hidden\" name=\"selectedproduct\" data-productname=\"" + value.productname + "\" value=\"" + value.productid + "\">" +
                              "<div class=\"item-inner\" style=\"padding-top:0px;padding-bottom:0px;padding-right:0px;\">" +
                              "<div class=\"item-title\" style=\"font-size:smaller; white-space: normal\">" + value.productname + "</div>" +
                             "</div></label></li>";
            });
            $$("#SelProductList ul").html(html);
        } else {
            $$("#SelProductList ul").html(noSelected);
        }
    } else {
        $$("#SelProductList ul").html(noSelected);
    }
}

function DelContrastSelect() {

    var delList = $$("input[name='ContrastSelect']:checked");
    if (delList.length == 0) {
        myApp.alert("请选择需要删除的项！", "提示");
        return;
    }

    $$.each(delList, function (index, value) {
        $$(value).parent().parent().remove();
        Delete($$(value).val());
        $$("a[specid='" + $$(value).val() + "']").removeAttr("disabled");
    });

    var storage = window.localStorage.getItem("ProductManual");
    if (storage == null || storage == "[]")
        $$("#pageContrastSelect").html(noContrastSelect);

    QueryShowNum();
}

function ClearContrastSelect() {
    var delList = $$("input[name='ContrastSelect']");

    if (delList.length > 0) {
        myApp.confirm('您确定要清空产品对比列表中的数据吗?', function (value) {
            $$("#pageContrastSelect").html(noContrastSelect);
            window.localStorage.removeItem("ProductManual");
            $$("#ShowNum").hide();
        });
        $$("a[specid]").removeAttr("disabled");
    }
}

function OpenContrastResult() {
    var selList = $$("input[name='ContrastSelect']:checked");
    if (selList.length < 2) {
        myApp.alert("抱歉，请选择2款以上产品型号！", "提示");
        return;
    }

    var productids = [];
    $$.each(selList, function (index, value) {
        productids.push($$(value).val());
    });

    if (serverURL == "") {
        loadPage('/Product/ContrastResult?productids=' + productids.join(","));
    } else {
        loadPage('ContrastResult.html?productids=' + productids.join(","));
    }
}

function QueryShowNum() {

    var storage = window.localStorage.getItem("ProductManual");
    if (storage != null) {
        var ProductManual = JSON.parse(storage);
        if (ProductManual.length > 0) {
            $$("#ShowNum").text(ProductManual.length);
            $$("#ShowNum").show();
        } else {
            $$("#ShowNum").hide();
        }
    } else {
        $$("#ShowNum").hide();
    }
}
